export enum GridColumnId {
  '#' = '#',
  'select-row-column' = 'select-row-column',
  'single-select-row-column' = 'single-select-row-column',
  CHILD_COUNT = 'CHILD_COUNT',
  ENTITY = 'ENTITY',
  ID = 'ID',
  NAME = 'NAME',
  TCLN_ID = 'TCLN_ID',
  active = 'active',
  additionalJQL = 'additionalJQL',
  assignedOn = 'assignedOn',
  assignedUser = 'assignedUser',
  assignee = 'assignee',
  assigneeFullName = 'assigneeFullName',
  assigneeId = 'assigneeId',
  assigneeLogin = 'assigneeLogin',
  assignees = 'assignees',
  atTechnologyId = 'atTechnologyId',
  attachmentCount = 'attachmentCount',
  attachmentPrune = 'attachmentPrune',
  attachments = 'attachments',
  automatable = 'automatable',
  automatedProject = 'automatedProject',
  automatedServerName = 'automatedServerName',
  automatedSuiteHasAttachment = 'automatedSuiteHasAttachment',
  automatedSuitesLifetime = 'automatedSuitesLifetime',
  automatedTestFullName = 'automatedTestFullName',
  automatedTestReference = 'automatedTestReference',
  automatedTestTechnology = 'automatedTestTechnology',
  automationPriority = 'automationPriority',
  automationRequestStatus = 'automationRequestStatus',
  availableDatasets = 'availableDatasets',
  baseUrl = 'baseUrl',
  bindableEntity = 'bindableEntity',
  bindableObjectIds = 'bindableObjectIds',
  bindingCount = 'bindingCount',
  bindingId = 'bindingId',
  boundToBlockingMilestone = 'boundToBlockingMilestone',
  boundToMilestone = 'boundToMilestone',
  boundToServer = 'boundToServer',
  btProject = 'btProject',
  bugtrackerName = 'bugtrackerName',
  callStepCount = 'callStepCount',
  campaignId = 'campaignId',
  campaignList = 'campaignList',
  campaignName = 'campaignName',
  canRunBdd = 'canRunBdd',
  category = 'category',
  categoryId = 'categoryId',
  categoryLabel = 'categoryLabel',
  cfId = 'cfId',
  childOfRequirement = 'childOfRequirement',
  code = 'code',
  color = 'color',
  colour = 'colour',
  completedOn = 'completedOn',
  configUrl = 'configUrl',
  conflictAssociation = 'conflictAssociation',
  connectionDate = 'connectionDate',
  copy = 'copy',
  coverageStepInfos = 'coverageStepInfos',
  coverages = 'coverages',
  coveragesCount = 'coveragesCount',
  createdBy = 'createdBy',
  createdOn = 'createdOn',
  criticality = 'criticality',
  ctpiId = 'ctpiId',
  cufId = 'cufId',
  datasetCount = 'datasetCount',
  datasetLabel = 'datasetLabel',
  datasetName = 'datasetName',
  datasets = 'datasets',
  date = 'date',
  default = 'default',
  defaultValue = 'defaultValue',
  delete = 'delete',
  description = 'description',
  detail = 'detail',
  directlyLinked = 'directlyLinked',
  directlyVerified = 'directlyVerified',
  draftedByAi = 'draftedByAi',
  duration = 'duration',
  edit = 'edit',
  editedLabel = 'editedLabel',
  email = 'email',
  enabled = 'enabled',
  endDate = 'endDate',
  environmentTags = 'environmentTags',
  environmentVariables = 'environmentVariables',
  evId = 'evId',
  event = 'event',
  execPlanType = 'execPlanType',
  executedBy = 'executedBy',
  execution = 'execution',
  executionCount = 'executionCount',
  executionDetails = 'executionDetails',
  executionEnvironment = 'executionEnvironment',
  executionExecutionMode = 'executionExecutionMode',
  executionExtenderHasAttachment = 'executionExtenderHasAttachment',
  executionId = 'executionId',
  executionLastExecutedOn = 'executionLastExecutedOn',
  executionLatestStatus = 'executionLatestStatus',
  executionName = 'executionName',
  executionOn = 'executionOn',
  executionOrder = 'executionOrder',
  executionPath = 'executionPath',
  executionReport = 'executionReport',
  executionServer = 'executionServer',
  executionStatus = 'executionStatus',
  executionSteps = 'executionSteps',
  executionsCount = 'executionsCount',
  expiryDate = 'expiryDate',
  featureIsCovered = 'featureIsCovered',
  fileName = 'fileName',
  firstName = 'firstName',
  flag = 'flag',
  folder = 'folder',
  forceSync = 'forceSync',
  fullName = 'fullName',
  gitLabField = 'gitLabField',
  habilitationCount = 'habilitationCount',
  hasAutoScript = 'hasAutoScript',
  hasBoundAutomatedTestReference = 'hasBoundAutomatedTestReference',
  hasBoundScmRepository = 'hasBoundScmRepository',
  hasBoundTestCaseRepository = 'hasBoundTestCaseRepository',
  hasChildren = 'hasChildren',
  hasDelegatedParameter = 'hasDelegatedParameter',
  hasDescription = 'hasDescription',
  hasExecution = 'hasExecution',
  hasExecutions = 'hasExecutions',
  hasLinkType = 'hasLinkType',
  hasParent = 'hasParent',
  hasPermissions = 'hasPermissions',
  hasResultUrl = 'hasResultUrl',
  hasValidConfiguration = 'hasValidConfiguration',
  hierarchyDisplayValue = 'hierarchyDisplayValue',
  iconName = 'iconName',
  id = 'id',
  idList = 'idList',
  iid = 'iid',
  importLogFilePath = 'importLogFilePath',
  importance = 'importance',
  importanceAuto = 'importanceAuto',
  inferredExecutionMode = 'inferredExecutionMode',
  infoListId = 'infoListId',
  inputType = 'inputType',
  interpreted = 'interpreted',
  isDefault = 'isDefault',
  isHighLevelRequirement = 'isHighLevelRequirement',
  isManual = 'isManual',
  isTemplate = 'isTemplate',
  issueCount = 'issueCount',
  issueIds = 'issueIds',
  issues = 'issues',
  issuesCount = 'issuesCount',
  itemTestPlanExecutionScope = 'itemTestPlanExecutionScope',
  itemTestPlanId = 'itemTestPlanId',
  items = 'items',
  iterationId = 'iterationId',
  iterationList = 'iterationList',
  iterationName = 'iterationName',
  iterations = 'iterations',
  iterationsCount = 'iterationsCount',
  jiraField = 'jiraField',
  joinedTags = 'joinedTags',
  key = 'key',
  kind = 'kind',
  label = 'label',
  labels = 'labels',
  lastConnectedOn = 'lastConnectedOn',
  lastExecutedBy = 'lastExecutedBy',
  lastExecutedOn = 'lastExecutedOn',
  lastExecutionMode = 'lastExecutionMode',
  lastExecutionStatus = 'lastExecutionStatus',
  lastExecutionStatuses = 'lastExecutionStatuses',
  lastModifiedBy = 'lastModifiedBy',
  lastModifiedOn = 'lastModifiedOn',
  lastName = 'lastName',
  lastStatus = 'lastStatus',
  lastSuccessfulSyncDate = 'lastSuccessfulSyncDate',
  lastSuccessfulUpdateDate = 'lastSuccessfulUpdateDate',
  lastSyncDate = 'lastSyncDate',
  lastUpdateDate = 'lastUpdateDate',
  lastUsage = 'lastUsage',
  latestExecutionId = 'latestExecutionId',
  launchedFrom = 'launchedFrom',
  linkCount = 'linkCount',
  linkedStandardRequirement = 'linkedStandardRequirement',
  linkedToCurrentStep = 'linkedToCurrentStep',
  linkedToRequirement = 'linkedToRequirement',
  linkedToStep = 'linkedToStep',
  links = 'links',
  login = 'login',
  milestoneBoundToOneObjectOfProject = 'milestoneBoundToOneObjectOfProject',
  milestoneEndDate = 'milestoneEndDate',
  milestoneId = 'milestoneId',
  milestoneIds = 'milestoneIds',
  milestoneLabels = 'milestoneLabels',
  milestoneStatus = 'milestoneStatus',
  milestones = 'milestones',
  modifiedBy = 'modifiedBy',
  modifiedOn = 'modifiedOn',
  name = 'name',
  namespace = 'namespace',
  nature = 'nature',
  nbIssues = 'nbIssues',
  nbStatusFailure = 'nbStatusFailure',
  nbStatusOther = 'nbStatusOther',
  nbStatusSuccess = 'nbStatusSuccess',
  nbStatusTotal = 'nbStatusTotal',
  nbTests = 'nbTests',
  nbVerifyingTestCases = 'nbVerifyingTestCases',
  newValue = 'newValue',
  node = 'node',
  noteTypes = 'noteTypes',
  oldValue = 'oldValue',
  open = 'open',
  optionCode = 'optionCode',
  optionName = 'optionName',
  optional = 'optional',
  options = 'options',
  overviewId = 'overviewId',
  ownerId = 'ownerId',
  ownerLogin = 'ownerLogin',
  paramCount = 'paramCount',
  parentEntityReference = 'parentEntityReference',
  partyCount = 'partyCount',
  partyId = 'partyId',
  partyName = 'partyName',
  perimeter = 'perimeter',
  permissionGroup = 'permissionGroup',
  permissions = 'permissions',
  pluginType = 'pluginType',
  prerequisite = 'prerequisite',
  priority = 'priority',
  profile = 'profile',
  project = 'project',
  projectCount = 'projectCount',
  projectId = 'projectId',
  projectName = 'projectName',
  qualifiedName = 'qualifiedName',
  range = 'range',
  recloneScmRepository = 'recloneScmRepository',
  reference = 'reference',
  remoteId = 'remoteId',
  remoteKey = 'remoteKey',
  remoteName = 'remoteName',
  remotePerimeterStatus = 'remotePerimeterStatus',
  remoteReqStatusAndState = 'remoteReqStatusAndState',
  remoteSelectType = 'remoteSelectType',
  remoteSelectValue = 'remoteSelectValue',
  reportId = 'reportId',
  reportSites = 'reportSites',
  repositoryPath = 'repositoryPath',
  reqMilestoneLocked = 'reqMilestoneLocked',
  reqVersionBoundToItem = 'reqVersionBoundToItem',
  requestStatus = 'requestStatus',
  requirementBoundToHighLevelRequirement = 'requirementBoundToHighLevelRequirement',
  requirementId = 'requirementId',
  requirementStatus = 'requirementStatus',
  requirementVersionId = 'requirementVersionId',
  requirementVersionProjectId = 'requirementVersionProjectId',
  requirementVersionProjectName = 'requirementVersionProjectName',
  requirements = 'requirements',
  restraintToActiveSprint = 'restraintToActiveSprint',
  reviewed = 'reviewed',
  role = 'role',
  role1Code = 'role1Code',
  role2 = 'role2',
  role2Code = 'role2Code',
  runningState = 'runningState',
  scmRepositoryId = 'scmRepositoryId',
  selectType = 'selectType',
  selectValue = 'selectValue',
  serverId = 'serverId',
  serverName = 'serverName',
  sourceTestCaseName = 'sourceTestCaseName',
  sourceTestCaseProjectName = 'sourceTestCaseProjectName',
  sourceTestCaseReference = 'sourceTestCaseReference',
  sprintList = 'sprintList',
  sprintName = 'sprintName',
  sprintReqVersionId = 'sprintReqVersionId',
  sprintReqVersionNameWithRef = 'sprintReqVersionNameWithRef',
  squashField = 'squashField',
  startExecution = 'startExecution',
  status = 'status',
  stepCount = 'stepCount',
  stepOrder = 'stepOrder',
  steps = 'steps',
  stopWorkflows = 'stopWorkflows',
  success = 'success',
  successRate = 'successRate',
  successfullyImportedOn = 'successfullyImportedOn',
  suiteId = 'suiteId',
  summary = 'summary',
  syncErrorLogFilePath = 'syncErrorLogFilePath',
  syncReqCreationSource = 'syncReqCreationSource',
  syncReqUpdateSource = 'syncReqUpdateSource',
  syncedAsFeature = 'syncedAsFeature',
  syncedAsIssue = 'syncedAsIssue',
  synchronisationCount = 'synchronisationCount',
  synchronisationEnable = 'synchronisationEnable',
  synchronisationPath = 'synchronisationPath',
  synchronizedRequirementsRatio = 'synchronizedRequirementsRatio',
  synchronizedSprintTicketsRatio = 'synchronizedSprintTicketsRatio',
  system = 'system',
  taProjectId = 'taProjectId',
  taServerId = 'taServerId',
  taskDivision = 'taskDivision',
  tcMilestoneLocked = 'tcMilestoneLocked',
  tclnId = 'tclnId',
  team = 'team',
  teamCount = 'teamCount',
  teamMembersCount = 'teamMembersCount',
  testAutomationServerKind = 'testAutomationServerKind',
  testCaseBoundToItem = 'testCaseBoundToItem',
  testCaseDeleted = 'testCaseDeleted',
  testCaseHasautoscript = 'testCaseHasautoscript',
  testCaseId = 'testCaseId',
  testCaseList = 'testCaseList',
  testCaseName = 'testCaseName',
  testCasePath = 'testCasePath',
  testCaseReference = 'testCaseReference',
  testPlanItemId = 'testPlanItemId',
  testSprintReqVersion = 'testSprintReqVersion',
  testSuites = 'testSuites',
  title = 'title',
  tokenId = 'tokenId',
  transmissionDate = 'transmissionDate',
  transmittedOn = 'transmittedOn',
  type = 'type',
  unDirectlyVerified = 'unDirectlyVerified',
  url = 'url',
  user = 'user',
  userGroup = 'userGroup',
  userId = 'userId',
  userSortColumn = 'userSortColumn',
  users = 'users',
  uuid = 'uuid',
  validationStatus = 'validationStatus',
  value = 'value',
  verifiedBy = 'verifiedBy',
  verifiedRequirementVersions = 'verifiedRequirementVersions',
  verifyingCalledTestCaseIds = 'verifyingCalledTestCaseIds',
  verifyingTestCaseId = 'verifyingTestCaseId',
  versionNumber = 'versionNumber',
  versionsCount = 'versionsCount',
  workflowId = 'workflowId',
  workflowViewer = 'workflowViewer',
  workingBranch = 'workingBranch',
  workingFolderPath = 'workingFolderPath',
}

export type StaticOrDynamicColumnId = GridColumnId | string;

export function getExtraPremiumColumnIdsForRequirementSearch(): string[] {
  return [
    GridColumnId.createdOn,
    GridColumnId.nature,
    GridColumnId.modifiedOn,
    GridColumnId.milestoneEndDate,
    GridColumnId.milestoneLabels,
    GridColumnId.milestoneStatus,
    GridColumnId.description,
    GridColumnId.childOfRequirement,
    GridColumnId.hasParent,
    GridColumnId.hasLinkType,
    GridColumnId.requirementBoundToHighLevelRequirement,
    GridColumnId.linkCount,
    GridColumnId.lastModifiedOn,
    GridColumnId.linkedStandardRequirement,
  ];
}

export function getExceptionColumnIdsForRequirementSearch(): string[] {
  return [GridColumnId.attachments, GridColumnId.coverages, GridColumnId.milestones];
}

export function getBasicColumnIdsForRequirementSearch(): string[] {
  return [
    '#',
    GridColumnId.category,
    GridColumnId.createdBy,
    GridColumnId.criticality,
    GridColumnId.detail,
    GridColumnId.folder,
    GridColumnId.id,
    GridColumnId.lastModifiedBy,
    GridColumnId.name,
    GridColumnId.projectName,
    GridColumnId.reference,
    GridColumnId.requirementId,
    GridColumnId.reqVersionBoundToItem,
    GridColumnId.status,
    GridColumnId.versionNumber,
    GridColumnId.versionsCount,
  ];
}

export function getExceptionColumnIdsForTestCaseSearch(): string[] {
  return [
    GridColumnId.attachments,
    GridColumnId.coverages,
    GridColumnId.datasets,
    GridColumnId.iterations,
    GridColumnId.milestones,
    GridColumnId.steps,
  ];
}

export function getBasicColumnIdsForTestCaseSearch(): string[] {
  return [
    '#',
    GridColumnId.automatable,
    GridColumnId.createdBy,
    GridColumnId.detail,
    GridColumnId.folder,
    GridColumnId.id,
    GridColumnId.importance,
    GridColumnId.lastModifiedBy,
    GridColumnId.name,
    GridColumnId.nature,
    GridColumnId.projectName,
    GridColumnId.reference,
    GridColumnId.status,
    GridColumnId.type,
    GridColumnId.testCaseBoundToItem,
  ];
}

export function getExtraPremiumColumnIdsForTestCaseSearch(): string[] {
  return [
    GridColumnId.automatedTestTechnology,
    GridColumnId.automationPriority,
    GridColumnId.callStepCount,
    GridColumnId.createdOn,
    GridColumnId.description,
    GridColumnId.executionCount,
    GridColumnId.hasAutoScript,
    GridColumnId.hasBoundAutomatedTestReference,
    GridColumnId.hasBoundScmRepository,
    GridColumnId.issueCount,
    GridColumnId.kind,
    GridColumnId.lastModifiedOn,
    GridColumnId.milestoneEndDate,
    GridColumnId.milestoneLabels,
    GridColumnId.milestoneStatus,
    GridColumnId.paramCount,
    GridColumnId.requestStatus,
    GridColumnId.testCaseHasautoscript,
    GridColumnId.transmittedOn,
    GridColumnId.draftedByAi,
  ];
}

export function getExceptionColumnIdsForITPISearch(): string[] {
  return [GridColumnId.label, GridColumnId.executionStatus];
}

export function getBasicColumnIdsForITPISearch(): string[] {
  return [
    '#',
    GridColumnId.projectName,
    GridColumnId.campaignName,
    GridColumnId.iterationName,
    GridColumnId.reference,
    GridColumnId.label,
    GridColumnId.importance,
    GridColumnId.datasetName,
    GridColumnId.testSuites,
    GridColumnId.automatable,
    GridColumnId.executionExecutionMode,
    GridColumnId.executionStatus,
    GridColumnId.lastExecutedBy,
    GridColumnId.lastExecutedOn,
    GridColumnId.execution,
  ];
}

export function getExtraPremiumColumnIdsForITPISearch(): string[] {
  return [
    GridColumnId.tclnId,
    GridColumnId.requestStatus,
    GridColumnId.milestoneLabels,
    GridColumnId.milestoneStatus,
    GridColumnId.milestoneEndDate,
    GridColumnId.assigneeLogin,
  ];
}

export function getMilestonesColumnIds(): string[] {
  return [
    GridColumnId.milestones,
    GridColumnId.milestoneLabels,
    GridColumnId.milestoneStatus,
    GridColumnId.milestoneEndDate,
  ];
}
